namespace :licenses do
  desc "Import json format license data in license engine"
  task :import => :environment do
    licenses = YAML.load(open(Rails.root + 'config/license.yml').read)
    licenses.each do |name, klass|
      puts name + "\n"
      system 'rake ' + name + ':import'
    end
  end
  
  desc "Copy migration file for license "
  task :install => :environment do
    licenses = YAML.load(open(Rails.root + 'config/license.yml').read)
    licenses.each do |name, klass|
      puts name + "\n"
      system 'rake ' + name + ':install:migrations'
    end
    puts "run 'rake db:migrate' if you can migrate database\n"
  end
end
